
/**
 * Module dependencies.
 */

var express = require('express')
  , routes = require('./routes')
  , user = require('./routes/user')
  , http = require('http')
  , path = require('path');

var app = express();

// all environments
app.set('port', process.env.PORT || 3000);
app.set('views', __dirname + '/views');
app.set('view engine', 'jade');
app.use(express.favicon());
app.use(express.logger('dev'));
app.use(express.bodyParser());
app.use(express.methodOverride());
app.use(app.router);
app.use(express.static(path.join(__dirname, 'public')));

// development only
if ('development' == app.get('env')) {
  app.use(express.errorHandler());
}

/////////////////////////////////////////////////////////
var MongoClient = require('mongodb').MongoClient;
var url = 'mongodb://localhost:27017/test';
var dbObj = null;
MongoClient.connect(url, function(err, db) {
	console.log("Connected correctly to server");
	dbObj = db;
	//db.close();
});
/////////////////////////////////////////////////////////
var mqtt = require('mqtt')
var client  = mqtt.connect('mqtt://192.168.204.163:1884')
client.on('connect', function () {
  client.subscribe('arduino');
  client.subscribe('cds');
  client.publish('arduino', 'Hello mqtt khejong')
})
client.on('message', function (topic, message) {
  // message is Buffer 
  console.log(message.toString())
  try {
	var obj = JSON.parse(message.toString()); 
	obj.created_at = new Date();
	var arduino = dbObj.collection(topic);
	arduino.save(obj, function(err, result){});
	
	var obj2 = JSON.parse(message.toString());
	obj2.created_at = new Date();
	obj2.type = topic;
	var sensors = dbObj.collection('sensors');
	sensors.save(obj2, function(err, result){});
	
  } catch (exception) {
	  //console.log(exception);
  }
  //client.end()
})
//////////////////////////////////////////////////////////

app.get('/', routes.index);
app.get('/arduino',function(req,res) {//RESTful API : 전체 조회
	var arduino = dbObj.collection('arduino');
	arduino.find({},{_id:0}).toArray(function(err,results) {
		res.send(JSON.stringify(results));
	});
});
app.get('/cds',function(req,res){
	var cds = dbObj.collection('cds');
	cds.find({},{_id:0}).toArray(function(err,results){
		res.send(JSON.stringify(results));
	});
});
app.get('/sensors/:type',function(req,res){
	var sensors = dbObj.collection('sensors');
	sensors.find({type:req.params.type},{_id:0}).toArray(
			function(err, results) {
				res.send(JSON.stringify(results));
			});
});
app.get('/arduino/buzzer', function(req,res) {
	client.publish('arduino', '1')
	res.send(JSON.stringify({buzzer:"on"}));
});
app.get('/users', user.list);

http.createServer(app).listen(app.get('port'), function(){
  console.log('Express server listening on port ' + app.get('port'));
});
